#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <Servo.h>

/////receiver address/////
RF24 radio(7,8);
const byte rxAddr[6] = "00001";

/////servo objects/////////
Servo myservo1;
Servo myservo2;
Servo myservo3;
Servo myservo4;
//Servo myservo;
//////////////////////////

/////motor variables/////
int motor_pins[2][3] = {{2,4,3},{A0,A1,5}};//d1,d2,a1
float motor_pwm[2] = {0,0};
int servo_pins[4] = {6,9,10,A2};
/////////////////////////



void setup()
{
  pinMode(motor_pins[0][0],OUTPUT);
  pinMode(motor_pins[0][1],OUTPUT);
  pinMode(motor_pins[0][2],OUTPUT);
  pinMode(motor_pins[1][0],OUTPUT);
  pinMode(motor_pins[1][1],OUTPUT);
  pinMode(motor_pins[1][2],OUTPUT);

  ////////attaching pins toservo///////
  myservo1.attach(6);
  myservo2.attach(9);
  myservo3.attach(10);
  myservo4.attach(A2);
  
 // myservo.attach(10);
  stopbot();
  
  
  /////receiver initialization/////
  while (!Serial);
  Serial.begin(115200);
  radio.begin();
  radio.openReadingPipe(0, rxAddr);
  radio.startListening();
  
  

}


////////////receiver structure/////////
typedef struct{
  float x_turn;
  float y_speed;
  float servo_1;
  float servo_2;
  float servo_3;
  float servo_4;
  }
A_t;
A_t duino;

//////////servo degrees////////////////
int servo1_degree = 0;
int servo2_degree = 0;
int servo3_degree = 0;
int servo4_degree = 0;
int pos=0;
///////////////////////////////////////
int count = 0;

/////////stopping bot////////////////
void stopbot()
{
  for(int i=0;i<2;i++)
    for(int j=0;j<3;j++)
      digitalWrite(motor_pins[i][j],LOW);
}
//////////////////////////////////////////

//////////////////////////////////////////
double motorwrite(int f_pin, int b_pin, int pwm_pin,double pwm){
  if(pwm<0)
  {
    digitalWrite(f_pin,HIGH);
    digitalWrite(b_pin,LOW);
    analogWrite(pwm_pin,-pwm);
  }      
  else if (pwm>0)
  {
    digitalWrite(b_pin,HIGH);
    digitalWrite(f_pin,LOW);
    analogWrite(pwm_pin,pwm);
  }
  else
  {
    digitalWrite(b_pin,HIGH);
    digitalWrite(f_pin,HIGH);
    analogWrite(pwm_pin,0);
  }
  }

///////////////////////////////////////
int initialization=0;  
////////////////////////////////////////////  
void loop()
{

  
  
  /////////reading data//////////
  if (radio.available())
  {
    //char text[32] = {0};
    radio.read(&duino, sizeof(duino));
    
    Serial.print(duino.x_turn);
    Serial.print(" ");
    Serial.print(duino.y_speed);
    Serial.print(" ");
    Serial.print(duino.servo_1);
    Serial.print(" ");
    Serial.print(duino.servo_2);
    Serial.print(" ");
    Serial.print(duino.servo_3);
    Serial.print(" ");
    Serial.print(duino.servo_4);
    Serial.print("\n");
  }
  ////////initialize motor ans servo/////////
  ////////////////////////////  
  
  //delay(100);
  count = duino.servo_1 + duino.servo_2 + duino.servo_3 + duino.servo_4;
  /////////taking actions////////////////
  if(count == 1)
  {
    if(duino.servo_1 == 1)
    {
      stopbot();
      servo1_degree = map(duino.y_speed,-30,30,0,180);
      myservo1.write(servo1_degree);
      delay(15);
      
    }
    else if(duino.servo_2 == 1)
    {
      stopbot();
      servo2_degree = map(duino.y_speed,-30,30,50,160);
      myservo2.write(servo2_degree);
      //delay(15);
      delay(15);
      
    }

    else if(duino.servo_3 == 1)
    {
      stopbot();
     
      
      servo3_degree = map(duino.y_speed,-30,30,0,180);
      
      myservo3.write(servo3_degree);
      //delay(100);
      Serial.println("ghar jaana hai");
      Serial.print(" ");
      Serial.println(servo3_degree);
      //myservo.write(pos);
      delay(15);
    }
    else if(duino.servo_4 == 1)
    {
      if(duino.y_speed > 10){
                myservo4.write(0);              // tell servo to go to position in variable 'pos'
                delay(15);                       // waits 15ms for the servo to reach the position
      }
      if(duino.y_speed < -10){
        myservo4.write(180);              // tell servo to go to position in variable 'pos'
        delay(15);                       // waits 15ms for the servo to reach the position
  }
  //delay(1);
        
        }
      /*
      stopbot();
      servo4_degree = map(duino.y_speed,-60,60,0,180);
      myservo4.write(servo4_degree);
      //delay(15);
      */
      
    
    
  }
  else
   {
     duino.y_speed =  map(duino.y_speed,-10,10,-180,180);
     duino.x_turn =  map(duino.x_turn,-10,10,-150,150);
     motor_pwm[0] = duino.y_speed + 0.5*duino.x_turn ; 
     motor_pwm[1] = duino.y_speed - 0.5*duino.x_turn;//right
     Serial.print(motor_pwm[0]);
     Serial.print(" ");
     Serial.print(motor_pwm[1]);
     Serial.print("\n");

     
     for(int i=0;i<2;i++)
      motorwrite(motor_pins[i][0],motor_pins[i][1],motor_pins[i][2],motor_pwm[i]);
      delay(15);
    }
    
  }
  
